

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>TestWeatherStation &mdash; pywws v12.10 documentation</title>
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '12.10',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="shortcut icon" href="../_static/pywws_logo.ico"/>
    <link rel="top" title="pywws v12.10 documentation" href="../index.html" />
    <link rel="up" title="Module code" href="index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" accesskey="U">Module code</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <h1>Source code for TestWeatherStation</h1><div class="highlight"><pre>
<span class="c">#!/usr/bin/env python</span>

<span class="sd">&quot;&quot;&quot;Test connection to weather station.</span>

<span class="sd">This is a simple utility to test communication with the weather</span>
<span class="sd">station. If this doesn&#39;t work, then there&#39;s a problem that needs to be</span>
<span class="sd">sorted out before trying any of the other programs. Likely problems</span>
<span class="sd">include not properly installing `libusb</span>
<span class="sd">&lt;http://libusb.wiki.sourceforge.net/&gt;`_ or `PyUSB</span>
<span class="sd">&lt;http://pyusb.berlios.de/&gt;`_. Less likely problems include an</span>
<span class="sd">incompatibility between libusb and some operating systems. The most</span>
<span class="sd">unlikely problem is that you forgot to connect the weather station to</span>
<span class="sd">your computer! ::</span>

<span class="sd">%s</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="n">__usage__</span> <span class="o">=</span> <span class="s">&quot;&quot;&quot;</span>
<span class="s"> usage: python TestWeatherStation.py [options]</span>
<span class="s"> options are:</span>
<span class="s">       --help           display this help</span>
<span class="s">  -d | --decode         display meaningful values instead of raw data</span>
<span class="s">  -h | --history count  display the last &quot;count&quot; readings</span>
<span class="s">  -l | --live           display &#39;live&#39; data</span>
<span class="s">  -m | --logged         display &#39;logged&#39; data</span>
<span class="s">  -u | --unknown        display unknown fixed block values</span>
<span class="s">  -v | --verbose        increase amount of reassuring messages</span>
<span class="s">                        (repeat for even more messages e.g. -vvv)</span>
<span class="s">&quot;&quot;&quot;</span>

<span class="n">__doc__</span> <span class="o">%=</span> <span class="n">__usage__</span>

<span class="n">__usage__</span> <span class="o">=</span> <span class="n">__doc__</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\n</span><span class="s">&#39;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span> <span class="o">+</span> <span class="n">__usage__</span>

<span class="kn">import</span> <span class="nn">datetime</span>
<span class="kn">import</span> <span class="nn">getopt</span>
<span class="kn">import</span> <span class="nn">sys</span>

<span class="kn">from</span> <span class="nn">pywws.Logger</span> <span class="kn">import</span> <span class="n">ApplicationLogger</span>
<span class="kn">from</span> <span class="nn">pywws</span> <span class="kn">import</span> <span class="n">WeatherStation</span>

<div class="viewcode-block" id="raw_dump"><a class="viewcode-back" href="../api/TestWeatherStation.html#TestWeatherStation.raw_dump">[docs]</a><span class="k">def</span> <span class="nf">raw_dump</span><span class="p">(</span><span class="n">pos</span><span class="p">,</span> <span class="n">data</span><span class="p">):</span>
    <span class="k">print</span> <span class="s">&quot;</span><span class="si">%04x</span><span class="s">&quot;</span> <span class="o">%</span> <span class="n">pos</span><span class="p">,</span>
    <span class="k">for</span> <span class="n">item</span> <span class="ow">in</span> <span class="n">data</span><span class="p">:</span>
        <span class="k">print</span> <span class="s">&quot;</span><span class="si">%02x</span><span class="s">&quot;</span> <span class="o">%</span> <span class="n">item</span><span class="p">,</span>
    <span class="k">print</span></div>
<div class="viewcode-block" id="main"><a class="viewcode-back" href="../api/TestWeatherStation.html#TestWeatherStation.main">[docs]</a><span class="k">def</span> <span class="nf">main</span><span class="p">(</span><span class="n">argv</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="k">if</span> <span class="n">argv</span> <span class="ow">is</span> <span class="bp">None</span><span class="p">:</span>
        <span class="n">argv</span> <span class="o">=</span> <span class="n">sys</span><span class="o">.</span><span class="n">argv</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">opts</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">getopt</span><span class="o">.</span><span class="n">getopt</span><span class="p">(</span>
            <span class="n">argv</span><span class="p">[</span><span class="mi">1</span><span class="p">:],</span> <span class="s">&quot;dh:lmuv&quot;</span><span class="p">,</span>
            <span class="p">(</span><span class="s">&#39;help&#39;</span><span class="p">,</span> <span class="s">&#39;decode&#39;</span><span class="p">,</span> <span class="s">&#39;history=&#39;</span><span class="p">,</span> <span class="s">&#39;live&#39;</span><span class="p">,</span> <span class="s">&#39;logged&#39;</span><span class="p">,</span> <span class="s">&#39;unknown&#39;</span><span class="p">,</span> <span class="s">&#39;verbose&#39;</span><span class="p">))</span>
    <span class="k">except</span> <span class="n">getopt</span><span class="o">.</span><span class="n">error</span><span class="p">,</span> <span class="n">msg</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: </span><span class="si">%s</span><span class="se">\n</span><span class="s">&#39;</span> <span class="o">%</span> <span class="n">msg</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">1</span>
    <span class="c"># check arguments</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">args</span><span class="p">)</span> <span class="o">!=</span> <span class="mi">0</span><span class="p">:</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="s">&#39;Error: no arguments allowed</span><span class="se">\n</span><span class="s">&#39;</span>
        <span class="k">print</span> <span class="o">&gt;&gt;</span><span class="n">sys</span><span class="o">.</span><span class="n">stderr</span><span class="p">,</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
        <span class="k">return</span> <span class="mi">2</span>
    <span class="c"># process options</span>
    <span class="n">history_count</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">decode</span> <span class="o">=</span> <span class="bp">False</span>
    <span class="n">live</span> <span class="o">=</span> <span class="bp">False</span>
    <span class="n">logged</span> <span class="o">=</span> <span class="bp">False</span>
    <span class="n">unknown</span> <span class="o">=</span> <span class="bp">False</span>
    <span class="n">verbose</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">o</span><span class="p">,</span> <span class="n">a</span> <span class="ow">in</span> <span class="n">opts</span><span class="p">:</span>
        <span class="k">if</span> <span class="n">o</span> <span class="o">==</span> <span class="s">&#39;--help&#39;</span><span class="p">:</span>
            <span class="k">print</span> <span class="n">__usage__</span><span class="o">.</span><span class="n">strip</span><span class="p">()</span>
            <span class="k">return</span> <span class="mi">0</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-d&#39;</span><span class="p">,</span> <span class="s">&#39;--decode&#39;</span><span class="p">):</span>
            <span class="n">decode</span> <span class="o">=</span> <span class="bp">True</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-h&#39;</span><span class="p">,</span> <span class="s">&#39;--history&#39;</span><span class="p">):</span>
            <span class="n">history_count</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">a</span><span class="p">)</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-l&#39;</span><span class="p">,</span> <span class="s">&#39;--live&#39;</span><span class="p">):</span>
            <span class="n">live</span> <span class="o">=</span> <span class="bp">True</span>
            <span class="n">logged</span> <span class="o">=</span> <span class="bp">False</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-m&#39;</span><span class="p">,</span> <span class="s">&#39;--logged&#39;</span><span class="p">):</span>
            <span class="n">live</span> <span class="o">=</span> <span class="bp">False</span>
            <span class="n">logged</span> <span class="o">=</span> <span class="bp">True</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-u&#39;</span><span class="p">,</span> <span class="s">&#39;--unknown&#39;</span><span class="p">):</span>
            <span class="n">unknown</span> <span class="o">=</span> <span class="bp">True</span>
        <span class="k">elif</span> <span class="n">o</span> <span class="ow">in</span> <span class="p">(</span><span class="s">&#39;-v&#39;</span><span class="p">,</span> <span class="s">&#39;--verbose&#39;</span><span class="p">):</span>
            <span class="n">verbose</span> <span class="o">+=</span> <span class="mi">1</span>
    <span class="c"># do it!</span>
    <span class="n">logger</span> <span class="o">=</span> <span class="n">ApplicationLogger</span><span class="p">(</span><span class="n">verbose</span><span class="p">)</span>
    <span class="n">ws</span> <span class="o">=</span> <span class="n">WeatherStation</span><span class="o">.</span><span class="n">weather_station</span><span class="p">()</span>
    <span class="n">raw_fixed</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_raw_fixed_block</span><span class="p">()</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">raw_fixed</span><span class="p">:</span>
        <span class="k">print</span> <span class="s">&quot;No valid data block found&quot;</span>
        <span class="k">return</span> <span class="mi">3</span>
    <span class="k">if</span> <span class="n">decode</span><span class="p">:</span>
        <span class="c"># dump entire fixed block</span>
        <span class="k">print</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">()</span>
        <span class="c"># dump a few selected items</span>
        <span class="k">print</span> <span class="s">&quot;min -&gt; temp_out -&gt;&quot;</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="s">&#39;min&#39;</span><span class="p">,</span> <span class="s">&#39;temp_out&#39;</span><span class="p">])</span>
        <span class="k">print</span> <span class="s">&quot;alarm -&gt; hum_out -&gt;&quot;</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="s">&#39;alarm&#39;</span><span class="p">,</span> <span class="s">&#39;hum_out&#39;</span><span class="p">])</span>
        <span class="k">print</span> <span class="s">&quot;rel_pressure -&gt;&quot;</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="s">&#39;rel_pressure&#39;</span><span class="p">])</span>
        <span class="k">print</span> <span class="s">&quot;abs_pressure -&gt;&quot;</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="s">&#39;abs_pressure&#39;</span><span class="p">])</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">ptr</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mh">0x0000</span><span class="p">,</span> <span class="mh">0x0100</span><span class="p">,</span> <span class="mh">0x20</span><span class="p">):</span>
            <span class="n">raw_dump</span><span class="p">(</span><span class="n">ptr</span><span class="p">,</span> <span class="n">raw_fixed</span><span class="p">[</span><span class="n">ptr</span><span class="p">:</span><span class="n">ptr</span><span class="o">+</span><span class="mh">0x20</span><span class="p">])</span>
    <span class="k">if</span> <span class="n">unknown</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">ws</span><span class="o">.</span><span class="n">fixed_format</span><span class="p">):</span>
            <span class="k">if</span> <span class="s">&#39;unk&#39;</span> <span class="ow">in</span> <span class="n">k</span><span class="p">:</span>
                <span class="k">print</span> <span class="n">k</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="n">k</span><span class="p">])</span>
        <span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">ws</span><span class="o">.</span><span class="n">fixed_format</span><span class="p">):</span>
            <span class="k">if</span> <span class="s">&#39;settings&#39;</span> <span class="ow">in</span> <span class="n">k</span> <span class="ow">or</span> <span class="s">&#39;display&#39;</span> <span class="ow">in</span> <span class="n">k</span> <span class="ow">or</span> <span class="s">&#39;alarm&#39;</span> <span class="ow">in</span> <span class="n">k</span><span class="p">:</span>
                <span class="n">bits</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">([</span><span class="n">k</span><span class="p">])</span>
                <span class="k">for</span> <span class="n">b</span> <span class="ow">in</span> <span class="nb">sorted</span><span class="p">(</span><span class="n">bits</span><span class="p">):</span>
                    <span class="k">if</span> <span class="s">&#39;bit&#39;</span> <span class="ow">in</span> <span class="n">b</span><span class="p">:</span>
                        <span class="k">print</span> <span class="n">k</span><span class="p">,</span> <span class="n">b</span><span class="p">,</span> <span class="n">bits</span><span class="p">[</span><span class="n">b</span><span class="p">]</span>
    <span class="k">if</span> <span class="n">history_count</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
        <span class="n">fixed_block</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_fixed_block</span><span class="p">()</span>
        <span class="k">print</span> <span class="s">&quot;Recent history&quot;</span>
        <span class="n">ptr</span> <span class="o">=</span> <span class="n">fixed_block</span><span class="p">[</span><span class="s">&#39;current_pos&#39;</span><span class="p">]</span>
        <span class="n">date</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">now</span><span class="p">()</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="n">second</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span> <span class="n">microsecond</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">history_count</span><span class="p">):</span>
            <span class="k">if</span> <span class="n">decode</span><span class="p">:</span>
                <span class="n">data</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_data</span><span class="p">(</span><span class="n">ptr</span><span class="p">)</span>
                <span class="k">print</span> <span class="n">date</span><span class="p">,</span> <span class="n">data</span>
                <span class="n">date</span> <span class="o">=</span> <span class="n">date</span> <span class="o">-</span> <span class="n">datetime</span><span class="o">.</span><span class="n">timedelta</span><span class="p">(</span><span class="n">minutes</span><span class="o">=</span><span class="n">data</span><span class="p">[</span><span class="s">&#39;delay&#39;</span><span class="p">])</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">raw_dump</span><span class="p">(</span><span class="n">ptr</span><span class="p">,</span> <span class="n">ws</span><span class="o">.</span><span class="n">get_raw_data</span><span class="p">(</span><span class="n">ptr</span><span class="p">))</span>
            <span class="n">ptr</span> <span class="o">=</span> <span class="n">ws</span><span class="o">.</span><span class="n">dec_ptr</span><span class="p">(</span><span class="n">ptr</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">live</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">data</span><span class="p">,</span> <span class="n">ptr</span><span class="p">,</span> <span class="n">logged</span> <span class="ow">in</span> <span class="n">ws</span><span class="o">.</span><span class="n">live_data</span><span class="p">():</span>
            <span class="k">print</span> <span class="s">&quot;</span><span class="si">%04x</span><span class="s">&quot;</span> <span class="o">%</span> <span class="n">ptr</span><span class="p">,</span>
            <span class="k">print</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s">&#39;%H:%M:%S&#39;</span><span class="p">),</span>
            <span class="k">del</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span>
            <span class="k">print</span> <span class="n">data</span>
    <span class="k">if</span> <span class="n">logged</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">data</span><span class="p">,</span> <span class="n">ptr</span><span class="p">,</span> <span class="n">logged</span> <span class="ow">in</span> <span class="n">ws</span><span class="o">.</span><span class="n">live_data</span><span class="p">(</span><span class="n">logged_only</span><span class="o">=</span><span class="bp">True</span><span class="p">):</span>
            <span class="k">print</span> <span class="s">&quot;</span><span class="si">%04x</span><span class="s">&quot;</span> <span class="o">%</span> <span class="n">ptr</span><span class="p">,</span>
            <span class="k">print</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s">&#39;%H:%M:%S&#39;</span><span class="p">),</span>
            <span class="k">del</span> <span class="n">data</span><span class="p">[</span><span class="s">&#39;idx&#39;</span><span class="p">]</span>
            <span class="k">print</span> <span class="n">data</span>
    <span class="k">del</span> <span class="n">ws</span>
    <span class="k">return</span> <span class="mi">0</span></div>
<span class="k">if</span> <span class="n">__name__</span> <span class="o">==</span> <span class="s">&quot;__main__&quot;</span><span class="p">:</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">(</span><span class="n">main</span><span class="p">())</span>
    <span class="k">except</span> <span class="ne">KeyboardInterrupt</span><span class="p">:</span>
        <span class="k">pass</span>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" size="18" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li><a href="../index.html">pywws v12.10 documentation</a> &raquo;</li>
          <li><a href="index.html" >Module code</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2009-12, Jim Easterbrook.
      Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.0.1.
    </div>
  </body>
</html>